﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace NumericUpDownFocus
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ViewModel ViewModel;
        private bool shouldRemoveFocused = true;

        public MainWindow()
        {
            InitializeComponent();
            this.ViewModel = new ViewModel();
            this.DataContext = this.ViewModel;
        }

        private void RadNumericUpDown_GotFocus(object sender, RoutedEventArgs e)
        {
            // For testing to simulate the issue
            if (this.ViewModel.MyValue == 1)
            {
                this.ViewModel.MyValue = 2;
            }


            if (shouldRemoveFocused)
            {
                shouldRemoveFocused = false;
                // Move to a parent that can take focus
                FrameworkElement parent = (FrameworkElement)this.NumericUpDown.Parent;
                while (parent != null && parent is IInputElement && !((IInputElement)parent).Focusable)
                {
                    parent = (FrameworkElement)parent.Parent;
                }

                DependencyObject scope = FocusManager.GetFocusScope(this.NumericUpDown);
                FocusManager.SetFocusedElement(scope, parent as IInputElement);
            }
            else
            {
                shouldRemoveFocused = true;
            }
        }

        private void NumericUpDown_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!shouldRemoveFocused)
            {
                this.NumericUpDown.Dispatcher.BeginInvoke(new Action(delegate()
                {
                    this.NumericUpDown.Focus();
                }));
            }
            else
            {
                shouldRemoveFocused = true;
            }
        }
    }
}
